//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UMonitorThread.h"
#include "UwMonitor.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//----- Constructor ------------------------------------------------------------
// how: 1) Create new Event, called MONITOREVENT
//      2) Create new SharedMemomry, this will contain the message
//      3) The pointer is set for easy access
__fastcall TMonitorThread::TMonitorThread(bool CreateSuspended)
   : TThread(CreateSuspended){                                 //1
   eve = new TTagMonitorEvent(MONITOREVENT,false);                     //2
   mem = new TTagMonitorSharedMem(MONITORDATA, sizeof(TMonitorMessage)); //3
   msg = (TMonitorMessage*)mem->getBuffer();
}//---------------------------------------------------------------------------

//----- Destructor -------------------------------------------------------------
// how: 1) Free the handle to the event
//      2) Free the handle to the sharedMemory
// note: this does not necesserily kill the event resp. memory.
//------------------------------------------------------------------------------
__fastcall TMonitorThread::~TMonitorThread(){
   delete eve;                                                // 1
   delete mem;                                                // 2
}//-----------------------------------------------------------------------------

//----- Execute ----------------------------------------------------------------
//Purpose: Main loop of the thread
// how:  1) Waits for an event
//       2) if the event occurs,
//       3)     updateLog is called synchronizedly
//       3.1)     store data in globla variables
//       3.2)     reset the signal
//       3.3)     call updateLog      
//       4) otherwise have a nap
//       5) if thread is not done, restart waiting at (1)
//------------------------------------------------------------------------------
void __fastcall TMonitorThread::Execute(){
   do {
      if ( eve->Wait(2000) ){          // 1,2
         mesType = msg->type;          // 3.1
         text = msg->text;             //
         errCode = msg->errCode;
         eve->Reset();                 // 3.2
         Synchronize(UpdateLog);       // 3.3
      } else                           // 3
         Sleep(100);                   // 4
   } while ( !Terminated );            // 5
}//-----------------------------------------------------------------------------

//----- UpdateLog --------------------------------------------------------------
//Purpose: fires the onMessage event
//Important: Call these function only within the syncronized Statement
void __fastcall TMonitorThread::UpdateLog(){
   if ( FOnMessage )
      FOnMessage(this, mesType, text, errCode);
}//-----------------------------------------------------------------------------
